#ifndef _ASM_PPC_ZORRO_H
#define _ASM_PPC_ZORRO_H

#include <asm/io.h>

#define z_readb(addr) in_8((unsigned char *)(addr))
#define z_readw(addr) in_be16((unsigned short *)(addr))
#define z_readl(addr) in_be32((unsigned int *)(addr))

#define z_writeb(val, port)	out_8((unsigned char *)(port), (val))
#define z_writew(val, port)	out_be16((unsigned short *)(port), (val))
#define z_writel(val, port)	out_be32((unsigned int *)(port), (val))

#define z_memset_io(a,b,c)	memset((void *)(a),(b),(c))
#define z_memcpy_fromio(a,b,c)	memcpy((a),(void *)(b),(c))
#define z_memcpy_toio(a,b,c)	memcpy((void *)(a),(b),(c))

extern inline void *z_remap_nocache_ser(unsigned long physaddr, 
					  unsigned long size)
{
	return __ioremap(physaddr, size, IOMAP_NOCACHE_SER);
}

extern inline void *z_remap_nocache_nonser(unsigned long physaddr, 
					     unsigned long size)
{
	return __ioremap(physaddr, size, IOMAP_NOCACHE_NONSER);
}

extern inline void *z_remap_writethrough(unsigned long physaddr,
					   unsigned long size)
{
	return __ioremap(physaddr, size, IOMAP_WRITETHROUGH);
}
extern inline void *z_remap_fullcache(unsigned long physaddr,
					unsigned long size)
{
	return __ioremap(physaddr, size, IOMAP_FULL_CACHING);
}

#define z_unmap iounmap
#define z_iounmap iounmap
#define z_ioremap z_remap_nocache_ser

#endif /* _ASM_PPC_ZORRO_H */
